Bug # 63692 (Accepted): Memory consumption while bulk inserting

Status: Closed Priority: Should have
Author: Stephan Großberndt Category: Performance
Created: 2014-12-08 Assigned To:
Updated: 2015-04-13 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus: Stabilization Sprint
Subject: High memory consumption for softRefs in ReferenceIndex->getRelations  while bulk inserting
Description

For every field of every record ReferenceIndex->getRelations executes:

                // Soft References:
                if (strlen($value) && ($softRefs = BackendUtility::explodeSoftRefParserList($conf['softref']))) {

The return value of explodeSoftRefParserList is not dependent on the record itself, but only table and field. Introducing a cache for
softRefs

public function getRelations($table, $row, $onlyField = '') {
    static $softRef_cache = array();

    [...]

                // Soft References:
                if (isset($softRef_cache[$table . 'f' . $field])) {
                    $softRefs = $softRef_cache[$table . 'f' . $field];
                } else {
                    $softRefs = BackendUtility::explodeSoftRefParserList($conf['softref']);
                    $softRef_cache[$table . 'f' . $field] = $softRefs;
                }
                if (strlen($value) && $softRefs) {

reduces when inserting 6500 records:

    -  8 instead of 51,024 calls to explodeSoftRefParserList
    -  0.52 seconds faster
    -  4kb used instead of 2,5MB

Associated revisions
Revision 72c3dec5 - 2015-04-13 16:58 - Stephan Großberndt

[BUGFIX] Cache results of explodeSoftRefParserList()

BackendUtility::explodeSoftRefParserList() is called with a very
limited set of input parameters, but processing is rather expensive.

Introduce a runtime cache to avoid processing the softrefs over
and over.
This especially speeds up calls from ReferenceIndex::getRelations(),
which is called many times.

Resolves: #63675
Releases: master, 6.2
Change-Id: I34a4392533828667c1b63b1ecb4ca12580e05e06
Reviewed-on: http://review.typo3.org/35190
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Andreas Fernandez <andreas.fernandez@aspedia.de>
Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Tested-by: Xavier Perseguers <xavier@typo3.org>

Revision 5a15c87f - 2015-04-13 17:32 - Stephan Großberndt

[BUGFIX] Cache results of explodeSoftRefParserList()

BackendUtility::explodeSoftRefParserList() is called with a very
limited set of input parameters, but processing is rather expensive.

Introduce a runtime cache to avoid processing the softrefs over
and over.
This especially speeds up calls from ReferenceIndex::getRelations(),
which is called many times.

Resolves: #63675
Releases: master, 6.2
Change-Id: I34a4392533828667c1b63b1ecb4ca12580e05e06
Reviewed-on: http://review.typo3.org/38662
Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Tested-by: Xavier Perseguers <xavier@typo3.org>
Reviewed-by: Andreas Fernandez <andreas.fernandez@aspedia.de>
Tested-by: Andreas Fernandez <andreas.fernandez@aspedia.de>

History
#1 - 2014-12-09 07:04 - Philipp Gampe
- Parent task set to #63692

#2 - 2014-12-09 14:34 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190
#3 - 2014-12-09 18:20 - Philipp Gampe
- Subject changed from High memory consumption in ReferenceIndex->getRelations while bulk inserting to High memory consumption for softRefs in 
ReferenceIndex->getRelations  while bulk inserting

#4 - 2014-12-10 18:32 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#5 - 2015-01-09 12:13 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#6 - 2015-01-10 00:20 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#7 - 2015-01-10 00:23 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#8 - 2015-01-10 00:24 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#9 - 2015-01-16 12:07 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#10 - 2015-01-16 12:24 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#11 - 2015-01-16 15:08 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#12 - 2015-01-21 13:57 - Gerrit Code Review
Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#13 - 2015-03-05 20:58 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35190

#14 - 2015-04-13 16:07 - Stephan Großberndt
- Target version changed from next-patchlevel to 6.2.12
- Sprint Focus set to Stabilization Sprint

#15 - 2015-04-13 16:58 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38662

#16 - 2015-04-13 17:00 - Stephan Großberndt
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:72c3dec560e8f0c5bbdf668b342d5c99937801f1.

#17 - 2015-04-13 17:04 - Xavier Perseguers
- Status changed from Resolved to Under Review
- % Done changed from 100 to 80

Still not ready for 6.2

#18 - 2015-04-13 17:32 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38662

#19 - 2015-04-13 17:49 - Andreas Fernandez
- Status changed from Under Review to Closed

Merged
